(function($){
    $(document).on('ready', function(){
        var $form = $('form[name="map_form"]');
        var $startInput = $('#start', $form);
        var $endInput = $('#end', $form);

        $form.on('submit', function(e){
            e.preventDefault();
            calcRoute();
        });

        // -------
        var defaultOrigin = window.localStorage.getItem('map_origin');
        var defaultDestination = window.localStorage.getItem('map_destination');
        if(undefined !== defaultOrigin && defaultOrigin){
           $startInput.val(defaultOrigin);
        }   

        if(undefined !== defaultDestination && defaultDestination){
           $endInput.val(defaultDestination);
        }

        if(defaultOrigin && defaultDestination){
            $('form[name="map_form"]').submit();
        }
        // ---------

        var $hddnCountries = $('form[name="map_form"] input[name="countries"][type="hidden"]');
        $('button.continue-btn','form[name="map_form"]').on('click', function(e){
            var countries = $hddnCountries.val().split(',').filter(function(el){return ('' !== el.trim());});
            var hasOrigin = ('' !== $startInput.val().toString().trim());
            var hasDestination = ('' !== $endInput.val().toString().trim());
            if( countries.length > 0 && hasOrigin && hasDestination){
                $startInput.css({border: 0});
                $endInput.css({border: 0});
                window.location = TolvignettenMapShortcode.targetUrl + '?' + decodeURIComponent($.param({
                    country: countries,
                    reset: TolvignettenMapShortcode.reset || true
                }));
            }
            else{
                $hddnCountries.val('');
                if(!hasOrigin){
                    $startInput.css({border: '1px solid red'});   
                }
                if(!hasDestination){
                    $endInput.css({border: '1px solid red'});
                }
            }
        });

        var directionsService;
        var map;
        var directionsDisplay;
        
        if(undefined ===  _TOLVIGNETTEN_COUNTRIES_){
            _TOLVIGNETTEN_COUNTRIES_ = {};
        }

        function calcRoute(provideRouteAlternatives)
        {
            if( undefined === provideRouteAlternatives ){
                provideRouteAlternatives = false;
            }

            calculatedAlternatives = provideRouteAlternatives;
            $startInput.css({border: 0});
            $endInput.css({border: 0});

            directionsService = new google.maps.DirectionsService();
            var start = document.getElementById("start").value;
            var end = document.getElementById("end").value;

            if (start.length > 0 && end.length > 0) {
                window.localStorage.setItem('map_origin', start);
                window.localStorage.setItem('map_destination', end);

                var request = {
                    origin: start,
                    destination: end,
                    travelMode: google.maps.TravelMode.DRIVING,
                    provideRouteAlternatives: provideRouteAlternatives
                };

                directionsService.route(request, function (result, status) {
                    if (status === google.maps.DirectionsStatus.OK) {
                        for (var i = 0, len = result.routes.length; i < len; i++) {

                            // check
                            var routeInfo = getRouteInfo(result, i);
                            if (routeInfo[0].length > 1) {
                                directionsDisplay.setDirections(result);
                                directionsDisplay.setRouteIndex(i);
                                return;
                            }

                        }
                        directionsDisplay.setDirections(result);
                    }
                });
            }
            else {
                if (start.length === 0) {
                    $startInput.css({border: 0});
                }
                if (end.length === 0) {
                    $endInput.css({border: 0});
                }
            }
        }

        function getRouteInfo(directions, routeIndex) 
        {
            var countries = [];
            var currentCountry = {};
            var countriesIsoCodes = [];
            currentCountry.name = directions.routes[routeIndex].legs[0].start_address.split(',').pop().trim();
            currentCountry.toll = false;
            currentCountry.isoCode =  _TOLVIGNETTEN_COUNTRIES_[currentCountry.name.trim()] || undefined;
            if(undefined !== currentCountry.isoCode){
                countriesIsoCodes.push(
                    currentCountry.isoCode
                );
            }

            var duration = directions.routes[routeIndex].legs[0].duration.text;
            var distance = directions.routes[routeIndex].legs[0].distance.text;

            for (var r in directions.routes) {
                var route = directions.routes[r];
                for (var i in route.legs) {
                    var leg = route.legs[i];
                    for (var s in leg.steps) {
                        var step = leg.steps[s];
                        var instructions = step.instructions;
                        var matched = instructions.match(/gaat ([^ ]+) binnen/i);
                        if (matched !== null) {
                            if (currentCountry !== null) {
                                countries.push(currentCountry);
                            }
                            currentCountry = {};
                            currentCountry.name = matched[1];
                            currentCountry.toll = false;                            
                            currentCountry.isoCode =  _TOLVIGNETTEN_COUNTRIES_[currentCountry.name.trim()] || undefined;
                            if(undefined !== currentCountry.isoCode){
                                countriesIsoCodes.push(
                                    currentCountry.isoCode
                                );
                            }
                        }

                        if (instructions.toLowerCase().indexOf('tolweg') >= 0) {
                            currentCountry.toll = true;
                        }
                    }
                }
            }

            if (currentCountry !== null) {
                countries.push(currentCountry);
            }

            if( countriesIsoCodes.length > 0 ){
                $hddnCountries.val(countriesIsoCodes.join(','));
            }

            return [countries, duration, distance];
        }

        function createHomepageGoogleMap() {
            if ($('#map').length == 0) {
                return;
            }

            var mapOptions = {
                center: {lat: 53.9638081, lng: 12.8166495},
                zoom: 4,
                streetViewControl: false,
                disableDefaultUI: false,
                scrollwheel: false,
                // styles: mapStyles,
                mapTypeControl: false,
                zoomControlOptions: {
                    style: google.maps.ZoomControlStyle.LARGE,
                    position: google.maps.ControlPosition.RIGHT_CENTER
                },
                panControlOptions: {
                    position: google.maps.ControlPosition.RIGHT_CENTER
                },
                zoomControl: true
            };

            var mapElement = document.getElementById('map');
            map = new google.maps.Map(mapElement, mapOptions);
            google.maps.event.trigger(map, 'resize');

            directionsDisplay = new google.maps.DirectionsRenderer({draggable: true});
            directionsDisplay.setMap(map);

            directionsService = new google.maps.DirectionsService();
            var start = $startInput.first().get(0);//document.getElementById('start');
            var end = $endInput.first().get(0); // .getElementById('end');

            var startAutocomplete = new google.maps.places.Autocomplete(start);
            startAutocomplete.bindTo('bounds', map);

            google.maps.event.addListener(startAutocomplete, 'place_changed', function () {
                calcRoute();
            });

            var endAutocomplete = new google.maps.places.Autocomplete(end);
            endAutocomplete.bindTo('bounds', map);

            google.maps.event.addListener(endAutocomplete, 'place_changed', function () {
                calcRoute();
            });

            google.maps.event.addListener(directionsDisplay, 'directions_changed', function () {                
                var directions = directionsDisplay.getDirections();
                for (var i = 0; i < directions.routes.length; i++) {
                    var routeInfo = getRouteInfo(directions, i);
                    var countries = routeInfo[0];
                    var duration = routeInfo[1];
                    var distance = routeInfo[2];
                    if (countries.length > 1) {
                        break;
                    }
                }                
            });

        }

        function init()
        {
            createHomepageGoogleMap();
            calcRoute();
        }

        init();
    });
})(jQuery);