<?php

/**
 * @param array $attrs
 *
 * @return string
 */
function tolvignetten_map_shortcode($attrs)
{
    tolvignetten_enqueue_required_libs();

    \wp_enqueue_script(
        'google_maps',
        '//maps.googleapis.com/maps/api/js?key=AIzaSyCOESH_Dq-5yMqW2dZvorjBGbRmHx5k_40&language=nl&libraries=places'
    );

    \wp_enqueue_script(
        'tolvignetten-countries-js',
        \tolvignetten_plugin_url(
            'public/js/countries.js'
        )
    );

    \wp_enqueue_script(
        'tolvignetten-map-js',
        \tolvignetten_plugin_url(
            'shortcodes/map/js/map.js'
        ),
        ['jquery']
    );

    \wp_localize_script('tolvignetten-map-js', 'TolvignettenMapShortcode', [
        'targetUrl' => (isset($attrs['target_path']) ? $attrs['target_path'] :  tolvignetten_get_default_map_target_url()),
        'reset' => (isset($attrs['reset']) ? $attrs['reset'] : true),
    ]);

    \wp_enqueue_style(
        'tolvignetten-map-css',
        \tolvignetten_plugin_url(
            'shortcodes/map/css/map.css'
        )
    );

    return \get_tolvignetten_map_shortcode_html(
        $attrs
    );
}

/**
 * @param array $attrs
 *
 * @return string
 */
function get_tolvignetten_map_shortcode_html($attrs)
{
    return tolvignetten_load_template(
        'shortcodes/map/templates/map-template.php',
        tolvignetten_process_shotcode_attrs(
            TOLVIGNETTEN_MAP_SHORCODE,
            $attrs
        )
    );
}

\add_shortcode(
    TOLVIGNETTEN_MAP_SHORCODE,
    'tolvignetten_map_shortcode'
);
