(function ($) {
    $(document).on('ready', function () {
        var parseQueryString = function (queryString) {
            var params = {}, queries, temp, i, l;
            queries = queryString.split("&");
            for (i = 0, l = queries.length; i < l; i++) {
                temp = queries[i].split('=');
                if (/\[(.+)?\]/gi.test(temp[0])) {
                    var key = temp[0].replace('[]', '');
                    if (undefined === params[key]) {
                        params[key] = [];
                    }
                    params[key].push(
                        temp[1]
                    );
                } else {
                    params[temp[0]] = temp[1];
                }
            }

            return params;
        };

        function adjustHeight(h) {
            $('#product_frame').prop(
                'height',
                75 + parseInt(h)
            );
        }

        function locationChanged(loc) {
            $.cookie(
                'prod_iframe_loc',
                loc,
                {
                    path: '/'
                }
            );
        }

        function storePartnerData(data) {
            var pd = {};
            try{
                pd = JSON.parse(
                    window.localStorage.getItem(
                        'pd'
                    )
                ) || {};
            }
            catch(e){
            }

            var partnerCookie = {};
            try{
                partnerCookie = JSON.parse(
                    $.cookie(
                        TolvignettenStoreShortcode.affiliateCookieName
                    )
                );
            }
            catch(e){

            }

            var changeIdFromCookie = undefined !== partnerCookie['id'] && parseInt(partnerCookie['id']) !== parseInt(pd['partner_id']);
            if( changeIdFromCookie ){
                data['partner_id'] = partnerCookie['id'].toString();
            }

            var store = false;
            for (var i in data) {
                if (!data.hasOwnProperty(i) || !/^(partner_)/g.test(i)) {
                    continue;
                }

                if (undefined !== pd[i] && undefined !== data[i] && data[i].toString() !== pd[i].toString()) {
                    pd[i] = data[i];
                    store = true;
                }
            }

            if(store){
                window.localStorage.setItem(
                    'pd',
                    JSON.stringify(
                        pd
                    )
                );
            }

            return store;
        }

        function buildLoc()
        {
            var loc = TolvignettenStoreShortcode.storeUrl;
            var params = {};
            if (window.location.search.length > 0) {
                params = parseQueryString(
                    window.location.search.substr(
                        1
                    )
                );
            }

            var queryLoc = undefined !== params['loc'] ? params['loc'] : null;

            if (undefined !== params['anvr']) {
                delete params['anvr'];
            }

            if (undefined !== params['bdr']) {
                delete params['bdr'];
            }

            var $iframe = $('iframe#product_frame');
            var iframePartnerId = $iframe.data('partner-id');
            var iframePartnerInfo = $iframe.data('partner-info');
            var iframePartnerAnvr = $iframe.data('partner-anvr');
            var iframePartnerBdr = $iframe.data('partner-bdr');

            params.partner_id = iframePartnerId ? iframePartnerId.toString().trim() : (TolvignettenStoreShortcode.partnerId || '');
            params.partner_info = iframePartnerInfo ? iframePartnerInfo.toString().trim() : (TolvignettenStoreShortcode.partnerInfo || '');
            params.partner_extra = {};

            var partner_anvr = iframePartnerAnvr ? iframePartnerAnvr.toString().trim() : (TolvignettenStoreShortcode.partnerAnvr || '');
            if( !partner_anvr ){
                params.partner_extra['anvr'] = partner_anvr;
            }

            var partner_bdr = iframePartnerBdr ? iframePartnerBdr.toString().trim() : (TolvignettenStoreShortcode.partnerBdr || '');
            if( !partner_bdr ){
                params.partner_extra['bdr'] = partner_bdr;
            }

            if (undefined === params['allowDeleteMainItems']) {
                params.allowDeleteMainItems = ('true' === TolvignettenStoreShortcode.allowDeleteMainItems.toString().toLowerCase());
            }

            if (undefined === params['showConfigurationSummary']) {
                params.showConfigurationSummary = ('true' === TolvignettenStoreShortcode.showConfigurationSummary.toString().toLowerCase());
            }

            if (undefined === params['showTrailerOption']) {
                params.showTrailerOption = ('true' === TolvignettenStoreShortcode.showTrailerOption.toString().toLowerCase());
            }

            if (undefined === params['showInfo']) {
                params.showInfo = ('true' === TolvignettenStoreShortcode.showInfo.toString().toLowerCase());
            }

            var defaultCountries = TolvignettenStoreShortcode.countries || [];
            params.country = params.country || defaultCountries;
            params.loc = window.top.location.href.replace(window.top.location.search, '');
            loc += '?' + decodeURIComponent($.param(params));

            return {
                queryLoc: queryLoc,
                loc: loc,
                params: params
            };
        }


        var locObject = buildLoc();
        var loc = locObject.loc;
        var params = locObject.params;
        var wasStored = storePartnerData(params);

        if (null !== locObject['queryLoc']) {
            loc = decodeURIComponent(locObject.queryLoc);
        }
        else if(
            !wasStored
            && undefined !== $.cookie('prod_iframe_loc')
            && (undefined === params['reset'] || 'false' === params['reset'])
        ) {
            loc = $.cookie('prod_iframe_loc');
        }
        else if (undefined !== params.reset) {
            var pageQueries = parseQueryString(window.location.search.substr(1));
            delete pageQueries.reset;
            History.replaceState(
                {},
                '',
                ('/' + params['loc'].toString().split('/')[3] + '?' + decodeURIComponent($.param(pageQueries)))
            );
        }

        $('#product_frame').prop('src', loc);

        $(window).on("message", function (e) {
            var data = e.originalEvent.data;
            var data = parseQueryString(data);

            var currentIframeQueryParams = decodeURIComponent(data.location).split('?');
            if (undefined !== currentIframeQueryParams[1]) {
                var currentIframeParams = parseQueryString(currentIframeQueryParams[1]);
                if (undefined !== currentIframeParams['SID']) {
                    $.cookie(
                        'prod_ui_sid',
                        currentIframeParams['SID'],
                        {
                            path: '/'
                        }
                    );

                    $.cookie(
                        'prod_ui_query',
                        window.location.search.substr(1),
                        {
                            path: '/'
                        }
                    );

                    $.ajax({
                        url: TolvignettenStoreShortcode.ajaxUrl,
                        method: 'GET',
                        dataType: 'json',
                        data: {
                            action: 'get_cart_items',
                            SID: currentIframeParams['SID']
                        }
                    }).done(function (response) {
                        if (undefined !== response['itemsNumber']) {
                            var itemsNumber = parseInt(response.itemsNumber);

                            if (isNaN(itemsNumber) || 0 === itemsNumber) {
                                $(".tolvignetten-cart-button").addClass('empty');
                                $(".tolvignetten-cart-button .badge").addClass('hide');
                            } else {

                                $(".tolvignetten-cart-button").removeClass('empty');
                                $(".tolvignetten-cart-button .badge").removeClass('hide');
                            }

                            $(".tolvignetten-cart-button .badge").text(
                                !isNaN(itemsNumber) ? itemsNumber : 0
                            );
                        }
                    });
                }
            }

            // height
            if (data.action == 'update') {
                adjustHeight(data.height);
                locationChanged(decodeURIComponent(data.location));
            } else if (data.action == 'load') {
                $('#spinner').show();
            } else if (data.action == 'finished_load') {
                $('#spinner').hide();
            }
        });

        $('#product_frame').on('load', function () {
            $('#spinner').hide();
            $('html,body').animate({
                scrollTop: $('#product_frame').offset().top - $('.tt-header').height() - 50
            }, 'slow');
        });
    });
})(jQuery);